extrn   v86r_eax:dword, v86r_ebx:dword, v86r_ecx:dword, v86r_edx:dword
extrn   v86r_esi:dword, v86r_edi:dword, v86r_ebp:dword
extrn   v86r_ah:byte, v86r_al:byte, v86r_bh:byte, v86r_bl:byte
extrn   v86r_ch:byte, v86r_cl:byte, v86r_dh:byte, v86r_dl:byte
extrn   v86r_ax:word, v86r_bx:word, v86r_cx:word, v86r_dx:word
extrn   v86r_si:word, v86r_di:word, v86r_bp:word
extrn   v86r_ds:word, v86r_es:word, v86r_fs:word, v86r_gs:word
extrn   v86r_ss:word, v86r_sp:word, v86r_cs:word, v86r_ip:word
extrn   _selcode:word, _seldata:word, _selzero:word, _lomembase:dword
extrn   _lomemtop:dword, _himembase:dword, _himemtop:dword, _pspa:dword
extrn   _code16a:dword, _code32a:dword, _getirqvect:dword, _setirqvect:dword
_sysbyte0       equ     _pm_info
extrn   _sysbyte0:byte, _irqmode:word

extrn   _getmem:near, _getlomem:near, _gethimem:near, _lomemsize:near
extrn   _himemsize:near, _ret:near, _exit:near, _getirqmask:near
extrn   _setirqmask:near

extrn   simint33:near
extrn   irqsoff:near
extrn   irqson:near

; Mode 03 shit...

extrn   csr_x:word, csr_y:word
extrn   orig_video:byte
extrn   fgcolor:byte, bgcolor:byte
extrn   printf:near
extrn   printf_d:dword          ; For Macro's don't use/call
extrn   printf_dest:near

; Convert physical pointer to realative pointer
@rlp    macro reg, ptr
	mov &reg,&ptr
	sub &reg,_code32a
endm

; Convert realative pointer to physical pointer
@php    macro reg, ptr
	mov &reg,&ptr
	add &reg,_code32a
endm

; Output a byte to DX
@outb           macro   val
	mov al,&val
	out dx,al
endm

; Output a word to DX
@outw           macro   val
	mov ax,&val
	out dx,ax
endm

; Get interrupt flag status
@gif    macro
	mov ax,902h
	int 31h
endm

; Get interrupt flag status and clear
@gifc   macro
	mov ax,900h
	int 31h
endm

; Get interrupt flag status and set
@gifs   macro
	mov ax,901h
	int 31h
endm

; Get interrupt flag status and set to AL (0=clear, 1=set)
@gifal  macro
	mov ah,9
	int 31h
endm

d equ dword ptr                         ; Some regular defs
w equ word ptr
b equ byte ptr
o equ offset
s equ short
f equ far ptr

; macros used throughout

pushw      macro constant  ; push word, used for pushing constants
	   
	   ;mov ax, constant            ; THIS SUX!! THIS USES FUCKING AX!?!
	   ;push ax

	   ; okay WORD pushing in 32 bits...
	
	   ; OPCODE for pushing imm32= 68h <DWORD>
	   ; Operator size flip prefix= 66h

	   ; SO, pushing a WORD:
	   
	   db  66h, 68h
	   dw  constant         ; Dit is wel handig, want je kan dus
				; geen pushw eax meer doen nu. (wat zonder
				; deze dw zou crashen als de nete!!)

	   endm

COMMENT ~
line       macro xx1,yy1,xx2,yy2,col
	   pushw xx1
	   pushw yy1
	   pushw xx2
	   pushw yy2
	   pushw col
	   call draw_line
	   endm

block      macro xx1,yy1,xx2,yy2,col
	   push xx1 yy1 xx2 yy2 col
	   call fill_block
	   endm
~

; macro to out a 16 bit value to an i/o port

out_16     macro register, value
	   ifdifi <register>, <dx> ; if dx not setup
	   mov   dx, register        ; then select register
	   endif
	   ifdifi <value>, <ax>    ; if ax not setup
	   mov   ax, value           ; then get data value
	   endif
	   out   dx, ax              ; set i/o register(s)
endm

; macro to out a 8 bit value to an i/o port

out_8      macro register, value
	   ifdifi <register>, <dx> ; if dx not setup
	   mov   dx, register        ; then select register
	   endif
	   ifdifi <value>, <al>    ; if al not setup
	   mov   al, value           ; then get data value
	   endif
	   out   dx, al              ; set i/o register
endm

; macro to clear registers to 0

clr        macro register, r2, r3, r4, r5, r6
	   ifnb  <register>
	   xor   register, register  ; set register = 0
	   clr   r2, r3, r4, r5, r6
	   endif
endm

; macros to decrement counter & jump on condition

loopx      macro register, destination
	   dec   register            ; counter--
	   jnz   destination         ; jump if not 0
endm

loopjz     macro register, destination
	   dec   register            ; counter--
	   jz    destination          ; jump if 0
endm

; printf macro

print      macro labl
	   push  eax
	   mov   eax, offset labl
	   mov   printf_d, eax
	   pop   eax
	   call  printf_dest
endm

; Align rel ptr to DWORD bounds...
aligndword macro reg
	   LOCAL not_needed

	   test  reg, 11b               ; Lower 2 bits are 0?
	   jz    short not_needed       ; Yups, already aligned. Exit.
	   and   reg, 0FFFFFFFCh        ; Clear lower 2 bits (if not zero)
	   add   reg, 4                 ; Next DWORD 
not_needed:

endm
